/*
 * arch/arm/mach-tcc93x/include/mach/gpio.h
 *
 * Written by <linux@telechips.com>
 * Modified: March 10, 2009
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ASM_ARCH_TCC93XX_GPIO_H
#define __ASM_ARCH_TCC93XX_GPIO_H

#define GPIO_PORTA	(0 << 5)
#define GPIO_PORTB	(1 << 5)
#define GPIO_PORTC	(2 << 5)
#define GPIO_PORTD	(3 << 5)
#define GPIO_PORTE	(4 << 5)
#define GPIO_PORTF	(5 << 5)
#define GPIO_PORTG	(6 << 5)
#define GPIO_PORTEXT1	(7 << 5)
#define GPIO_PORTEXT2	(8 << 5)
#define GPIO_PORTEXT3	(9 << 5)
#define GPIO_PORTEXT4	(10 << 5)
#define GPIO_PORTEXT14	(11 << 5)

#define TCC_GPA(x)	(GPIO_PORTA | (x))
#define TCC_GPB(x)	(GPIO_PORTB | (x))
#define TCC_GPC(x)	(GPIO_PORTC | (x))
#define TCC_GPD(x)	(GPIO_PORTD | (x))
#define TCC_GPE(x)	(GPIO_PORTE | (x))
#define TCC_GPF(x)	(GPIO_PORTF | (x))
#define TCC_GPG(x)	(GPIO_PORTG | (x))
#define TCC_GPEXT1(x)	(GPIO_PORTEXT1 | (x))
#define TCC_GPEXT2(x)	(GPIO_PORTEXT2 | (x))
#define TCC_GPEXT3(x)	(GPIO_PORTEXT3 | (x))
#define TCC_GPEXT4(x)	(GPIO_PORTEXT4 | (x))
#define TCC_GPEXT14(x)	(GPIO_PORTEXT14 | (x))

#define gpio_get_value	__gpio_get_value
#define gpio_set_value	__gpio_set_value
#define gpio_cansleep	__gpio_cansleep

int gpio_to_irq(unsigned gpio);

#if defined(CONFIG_MACH_TCC9300)
#define ARCH_NR_GPIOS   (GPIO_PORTEXT14|16)
#elif defined(CONFIG_MACH_TCC9300CM)
#define ARCH_NR_GPIOS   (GPIO_PORTEXT3|16)
#elif defined(CONFIG_MACH_TCC9300ST)
#define ARCH_NR_GPIOS   (GPIO_PORTG|32)
#endif

#include <asm-generic/gpio.h>

#endif
