
/****************************************************************************
 *   FileName    : tca_remocon.h
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/

//*******************************************
//	Remote controller define
//*******************************************

//Low Bit
#if (defined(CONFIG_ARCH_TCC92X) || defined(CONFIG_ARCH_TCC93XX))
#define LOW_MIN			0x0700
#define LOW_MAX			0x0B00
//High Bit
#define HIGH_MIN		0x1800
#define HIGH_MAX		0x1D00
//Start Bit
#define START_MIN		0x4000
#define START_MAX		0x5000
//Repeat Bit
#define REPEAT_MIN		0x2000
#define REPEAT_MAX		0x2700
#else
//Low Bit
#define LOW_MIN			0x0500
#define LOW_MAX			0x0B00
//High Bit
#define HIGH_MIN		0x1000
#define HIGH_MAX		0x1D00
//Start Bit
#define START_MIN		0x2500
#define START_MAX		0x5000
#endif


/*****************************************************************************
*
* IR remote controller scancode
*
******************************************************************************/
#define REM_ID_ERROR	0xFF

	#define REMOCON_ID		0x1867

	#define SCAN_PWR		0x0001

	#define SCAN_HOME		0x41BE
	#define SCAN_PLAY		0x45BA
	#define SCAN_STOP		0x0001
	#define SCAN_PAUSE		0x0001
	#define SCAN_FB 		0x0001
	#define SCAN_FF 		0x0001

	#define SCAN_MUTE		0x0001
	#define SCAN_VOLUP		0x748B
	#define SCAN_VOLDN		0x0CF3

	#define SCAN_MENU		0x5CA3

	#define SCAN_UP			0x1CE3
	#define SCAN_DOWN		0x21DE
	#define SCAN_LEFT		0x3CC3
	#define SCAN_RIGHT		0x01FE

	#define SCAN_MTS		0x8C73
	#define SCAN_SPEED		0xCC33

	#define SCAN_ENTER		0x7C83
	#define SCAN_BACK		0x619E

/*****************************************************************************
*
* External Variables
*
******************************************************************************/
#define NO_KEY		0

static SCANCODE_MAPPING key_mapping[] = 
{
	{SCAN_MENU,		139},

	{SCAN_UP, 		103},
	{SCAN_DOWN,		108},
	{SCAN_LEFT,		105},
	{SCAN_RIGHT,	106},

	{SCAN_ENTER,	28},
	{SCAN_BACK,		158},

	{SCAN_MUTE,		200},
	{SCAN_VOLUP,	115},
	{SCAN_VOLDN,	114},

	{SCAN_MTS,		4},
	{SCAN_SPEED,	10},

	{SCAN_PLAY,		198},
	{SCAN_FB,		201},
	{SCAN_FF, 		202},
	{SCAN_STOP, 	199},

	{SCAN_HOME,		102},
};

