/****************************************************************************
 *   FileName    : tca_cs8900_hwset.h
 *   Description : 
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/
#ifndef __TCA_CS8900_HWSET_H__
#define __TCA_CS8900_HWSET_H__

#ifdef __KERNEL__
#	if defined(_TCC79x_)
#		include <mach/tcc79x.h>
//#		include <asm/arch/tcc79x.h>
#	elif defined(_TCC83x_)
#		include <asm/arch/tcc83x_virt.h>
#	endif
#else
#	if defined(_TCC79x_)
#		include "TCC79x_Virtual.h"
#	elif defined(_TCC83x_)
#		include "TCC83x_Virtual.h"
#	endif
#endif

#ifdef __KERNEL__
#ifdef CONFIG_ARCH_TCC79X
	#define IRQ_ETH			IRQ_EI0
	#define PORT_BASE_ADDR	0x40000300
#elif CONFIG_ARCH_TCC83X
	#define IRQ_ETH			INT_EI1
	#define PORT_BASE_ADDR	0x60000300
#endif
#else	/*not __KERNEL__*/
/* Packet page base address */
#if defined(_TCC79x_) 
	#define IO_PACKET_PAGE_BASE_ADDR 0xBB000300
#elif defined(_TCC83x_)	
	#define IO_PACKET_PAGE_BASE_ADDR 0xB6000300
#endif
#endif	/*__KERNEL__*/

extern void tca_cs8900_init(void);
extern void tca_cs8900_irq(void);
extern void tca_cs8900_clear_irq(void);

#endif /*__TCA_CS8900_HWSET_H__*/

