
/****************************************************************************
 *   FileName    : tca_rtc.h
 *   Description : 
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/
/*****************************************************************************
*
* Defines
*
******************************************************************************/


/*****************************************************************************
*
* Enum
*
******************************************************************************/


/*****************************************************************************
*
* Type Defines
*
******************************************************************************/
#define FROM_BCD(n)     ((((n) >> 4) * 10) + ((n) & 0xf))
#define TO_BCD(n)       ((((n) / 10) << 4) | ((n) % 10))
#define RTC_YEAR_DATUM  1980


/*****************************************************************************
*
* Structures
*
******************************************************************************/
typedef struct _rtctime { 
  unsigned int wYear; 
  unsigned int wMonth; 
  unsigned int wDayOfWeek; 
  unsigned int wDay; 
  unsigned int wHour; 
  unsigned int wMinute; 
  unsigned int wSecond; 
  unsigned int wMilliseconds; 
} rtctime;


/*****************************************************************************
*
* External Variables
*
******************************************************************************/


/*****************************************************************************
*
* External Functions
*
******************************************************************************/
#ifdef __cplusplus
extern 
"C" { 
#endif

void tca_rtc_gettime(rtctime *pTime);
void tca_rtc_settime(rtctime *pTime);
unsigned int	tca_rtc_checkvalidtime(void);

#ifdef __cplusplus
 } 
#endif


