/*
tcc for UART
*/
#ifndef	__DEFINES_H__
#define	__DEFINES_H__


#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************************************
*
* Defines
*
******************************************************************************/


//UART
#define	HwUART_IER_EMSI_EN				Hw3								// Enable Modem status interrupt
#define	HwUART_IER_EMSI_DIS				~Hw3							// Disable Modem status interrupt
#define	HwUART_IER_ELSI_EN				Hw2								// Enable receiver line status interrupt
#define	HwUART_IER_ELSI_DIS				~Hw2							// Disable receiver line status interrupt
#define	HwUART_IER_ETXI_EN				Hw1								// Enable transmitter holding register empty interrupt
#define	HwUART_IER_ETXI_DIS				~Hw1							// Disable transmitter holding register empty interrupt
#define	HwUART_IER_ERXI_EN				Hw0								// Enable received data available interrupt
#define	HwUART_IER_ERXI_DIS				~Hw0							// Disable received data available interrupt
#define	HwUART_IIR_STF					Hw27							// 1:TX is done (SmartCard TX done flag)
#define	HwUART_IIR_IPF					Hw0								// 1:Interrupt has not generated, 0:Interrupt pending

#define	HwEXTREQ_UART1_RX						Hw30							// Connected Hardware = UART Channel 1 Receiver
#define	HwEXTREQ_UART1_TX						Hw29							// Connected Hardware = UART Channel 1 Tranceiver
#define	HwEXTREQ_UART0_RX						Hw27							// Connected Hardware = UART Channel 0 Receiver
#define	HwEXTREQ_UART0_TX						Hw26							// Connected Hardware = UART Channel 0 Tranceiver
#define	HwEXTREQ_UART3_RX						Hw11							// Connected Hardware = UART Channel 3 Receiver
#define	HwEXTREQ_UART3_TX						Hw10							// Connected Hardware = UART Channel 3 Tranceiver
#define	HwEXTREQ_UART2_RX						Hw9								// Connected Hardware = UART Channel 2 Receiver
#define	HwEXTREQ_UART2_TX						Hw8								// Connected Hardware = UART Channel 2 Tranceiver

//DMA
#define	HwCHCTRL_SYNC_EN						Hw13							// Synchronize Hardware Request
#define	HwCHCTRL_TYPE_SL						(Hw9+Hw8)						// SINGLE transfer with level-triggered detection
#define	HwCHCTRL_BSIZE_1						HwZERO							// 1 Burst transfer consists of 1 read or write cycle
#define	HwCHCTRL_WSIZE_8						HwZERO							// Each cycle read or write 8bit data
#define	HwCHCTRL_IEN_ON						Hw2								// At the same time the FLAG goes to 1, DMA interrupt request is generated
#define	HwCHCTRL_FLAG							Hw3								// W : Clears FLAG to 0, R : Represents that all hop of transfer are fulfilled
#define	HwCHCTRL_CONT_C						Hw15							// DMA transfer begins from C_SADR / C_DADR address. It must be used after the former transfer has been executed, so that C_SADR and C_DADR contain a meaningful vlaue
#define	HwCHCTRL_REP_EN						Hw1								// The DMA channel remains enabled. When another DMA request has occurred, the DMA channel start transfer data again with the same manner(type,address,increment,mask) as the latest transfer of that channel

/*****************************************************************************
*
* APIs
*
******************************************************************************/

void tcc_serial_iobusonoff(int nCh, int nPort, int bOn);
void tcc_serial_portinit(int nCh, int nPort, unsigned long* pvGpioAddr, unsigned long* pvPortMuxAddr);
void tcc_serial_portdeinit(int nCh);
int	tcc_dma_ctrl(int m_DmaNumber, unsigned long* pVirtualDmaAddr);
int	tcc_dma_dmacurrentaddress(int m_DmaNumber, unsigned long* pVirtualDmaAddr);
int tcc_dma_dmadeststartaddress(int m_DmaNumber,unsigned long* pVirtualDmaAddr);
int tcc_dma_clrien(int m_DmaNumber, unsigned long* pVirtualDmaAddr);
int tcc_dma_setien(int m_DmaNumber, unsigned long* pVirtualDmaAddr);
unsigned int tcc_serial_dmaclrinterrupt(unsigned nDmanum, unsigned long* pVirtualDmaAddr);
void tcc_dma_setconfig( unsigned uCH,	void* pSRT, 	
					   unsigned uSPARAM,	void* pDST, 	
					   unsigned uDPARAM,	unsigned	uCHCTRL,	
					   unsigned uSize,	unsigned channel,	
					   unsigned mode, unsigned long* pVirtualDmaAddr);

#ifdef __cplusplus
}
#endif

#endif
