/*
 * linux/drivers/tccfb.h
 * Copyright (c) Telechips, 2008
 *
 */

#ifndef __TCCFB_H
#define __TCCFB_H

#ifdef CONFIG_EARLYSUSPEND
#include <linux/earlysuspend.h>
#endif
struct tccfb_info {
	struct fb_info		*fb;
	struct device		*dev;

	//struct tccfb_mach_info *mach_info;

	/* raw memory addresses */
	dma_addr_t		map_dma;	/* physical */
	u_char *		map_cpu;	/* virtual */
	u_int			map_size;

	/* addresses of pieces placed in raw buffer */
	u_char *		screen_cpu;	/* virtual address of buffer */
	dma_addr_t		screen_dma;	/* physical address of buffer */

#ifdef CONFIG_HAS_EARLYSUSPEND
        struct early_suspend early_suspend;
#endif
};

#define PALETTE_BUFF_CLEAR (0x80000000)	/* entry is clear/invalid */

int tccfb_init(void);

#endif
