/*
 * include/asm-arm/arch-tcc83x/entry-macro.S
 *
 * Low-level IRQ helper macros for OMAP-based platforms
 *
 * This file is licensed under  the terms of the GNU General Public
 * License version 2. This program is licensed "as is" without any
 * warranty of any kind, whether express or implied.
 */
#include <asm/hardware.h>
#include <asm/arch/irqs.h>

 	.macro	disable_fiq
	.endm

	.macro  get_irqnr_preamble, base, tmp
	.endm

	.macro  arch_ret_to_user, tmp1, tmp2
	.endm

	.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp

		ldr	\base, =0xF1003000	@ base address of IRQ_A registers 

		@@ try the interrupt MSTS register, since it is there

		ldr	\irqstat, [ \base, #0x00000014 ]
		teq	\irqstat, #0
		beq	1002f

		@@ the number specified is not a valid irq, so try
		@@ and work it out for ourselves


		@@ 1. check IRQ_T32
		mov		\tmp, #1
		ands	\irqnr, \irqstat, \tmp, LSL #INT_TC32
		mov		\irqnr, #INT_TC32
		bne		1002f
		
		@@ 2. check IRQ A group
		mov		\irqnr, #0					@@ start here
		tst		\irqstat, #0xFF
		moveq	\irqstat, \irqstat, LSR #8
		addeq	\irqnr, \irqnr, #8
		tsteq	\irqstat, #0xFF
		moveq	\irqstat, \irqstat, LSR #8
		addeq	\irqnr, \irqnr, #8
		tsteq	\irqstat, #0xFF
		moveq	\irqstat, \irqstat, LSR #8
		addeq	\irqnr, \irqnr, #8

		tst		\irqstat, #0x0F
		moveq	\irqstat, \irqstat, LSR #4
		addeq	\irqnr, \irqnr, #4

		tst		\irqstat, #0x03
		moveq	\irqstat, \irqstat, LSR #2
		addeq	\irqnr, \irqnr, #2

		tst		\irqstat, #0x01
		addeqs	\irqnr, \irqnr, #1
		@@ work out which irq A we got

		@@ we have the value

1002:
		@@ exit here, Z flag unset if IRQ

	.endm

