/*
 * include/linux/regulator/act8810.h
 *
 * Copyright (C) 2009 Telechips, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __LINUX_REGULATOR_ACT8810_H
#define __LINUX_REGULATOR_ACT8810_H

#define ACT8810_NUM_REGULATORS	3 //6

#define ACT8810_OUT1	0
#define ACT8810_OUT2	1
#define ACT8810_OUT3	2
#define ACT8810_OUT4	3
#define ACT8810_OUT5	4
#define ACT8810_OUT6	5

#define ACT8810_REG_OUT1_STBY	0x10
//#define ACT8810_REG_OUT1_STBY	0x11
#define ACT8810_REG_OUT1_CTRL	0x12
#define ACT8810_REG_OUT1_VSET	0x13


// REG1/VRANGE 0
#define ACT8810_OUT_0_800V	0x01
#define ACT8810_OUT_0_850V	0x09
#define ACT8810_OUT_0_900V	0x0B
#define ACT8810_OUT_0_950V	0x0D
#define ACT8810_OUT_1_000V	0x0F
#define ACT8810_OUT_1_050V	0x11
#define ACT8810_OUT_1_100V	0x13
#define ACT8810_OUT_1_150V	0x15
#define ACT8810_OUT_1_200V	0x17
#define ACT8810_OUT_1_250V	0x19
#define ACT8810_OUT_1_300V	0x1B
#define ACT8810_OUT_1_350V	0x1D
#define ACT8810_OUT_1_400V	0x1F
#define ACT8810_OUT_1_500V	0x23
#define ACT8810_OUT_1_600V	0x27
#define ACT8810_OUT_1_700V	0x2B
#define ACT8810_OUT_1_750V	0x2D
#define ACT8810_OUT_1_800V	0x2F
#define ACT8810_OUT_1_850V	0x31
#define ACT8810_OUT_1_900V	0x33
#define ACT8810_OUT_2_000V	0x37
#define ACT8810_OUT_2_100V	0x3B
#define ACT8810_OUT_2_200V	0x3F

int act8810_register_regulator(struct device *dev, int reg);

#endif
