/****************************************************************************
 *   TCC Version 0.6
 *   Copyright (c) telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
****************************************************************************/

#define IO_CKC_Fxin 120000

/************************************************************************
 * I2C define
 ***********************************************************************/
#define		i2c_ack			0					// i2c acknowledgement
#define		i2c_noack		1					// i2c no acknowledgement
#define		i2c_err			0					// i2c error occurs
#define		i2c_ok			1					// i2c error does not occurs


// I2C-bus standard mode timing setting
#define		i2c_Tbuf		400		//200
#define		i2c_Tsetup		8		//4//8		// above min 250ns
#define		i2c_Thold		200		//100		// the fm_Thold is a basic time as above min 5us
#define		i2c_Tcatch		100		//50		// the half of the i2c_Thold

#define 		I2C_SUBADDR_NOUSE 	-1

// Message 
#define I2C_FREE	0
#define I2C_USED	1

//extern char I2C_use_flag;

// Functions
extern unsigned char alsa_i2c_read(unsigned int i2ctgt, unsigned char SlaveAddr, char addr, unsigned char *ptr, unsigned char bytes);
extern unsigned char alsa_i2c_write(unsigned int i2ctgt, unsigned char SlaveAddr, char addr, unsigned char *ptr, unsigned char bytes);
void alsa_i2c_init(void);
extern int alsa_i2c_register(unsigned int i2ctgt);
void alsa_CODEC_SEND_CMD(unsigned char hb, unsigned char lb);
int	alsa_DDI_I2C_Initialize(void);


enum 
{
	I2C_CODEC,
	I2C_FM,
	I2C_CAMERA,
	I2C_TVOUT,
	I2C_MAX_VECTOR
} ;

enum
{
	I2C_CLK,
	I2C_DATA,
	I2C_SIGNAL_BUS
};

#define		i2c_wr			(*(volatile unsigned long int *)(I2C_Vector[I2C_DATA].tgtaddr+0x04) |= (I2C_Vector[I2C_DATA].port));
#define		i2c_rd			(*(volatile unsigned long int *)(I2C_Vector[I2C_DATA].tgtaddr+0x04) &= ~(I2C_Vector[I2C_DATA].port));
#define		i2c_clk_hi		(*(volatile unsigned long int *)(I2C_Vector[I2C_CLK].tgtaddr) |= (I2C_Vector[I2C_CLK].port));
#define		i2c_clk_lo		(*(volatile unsigned long int *)(I2C_Vector[I2C_CLK].tgtaddr) &= ~(I2C_Vector[I2C_CLK].port));	
#define		i2c_data_hi		(*(volatile unsigned long int *)(I2C_Vector[I2C_DATA].tgtaddr) |= (I2C_Vector[I2C_DATA].port)); 	   
#define		i2c_data_lo		(*(volatile unsigned long int *)(I2C_Vector[I2C_DATA].tgtaddr) &= ~(I2C_Vector[I2C_DATA].port)); 	 


//**********************************************************************
#define codec_slaveaddr	0x34


typedef struct I2C_SW_READ_s
{
	unsigned int i2ctgt;
	unsigned char SlaveAddr;
	char subaddr;
	unsigned char *ptr;
	unsigned char bytes;
	unsigned char i2c_return;
} I2C_SW_READ_t;

typedef struct I2C_SW_WRITE_s
{
	unsigned int i2ctgt;
	unsigned char SlaveAddr;
	char subaddr;
	unsigned char *ptr;
	unsigned char bytes;
	unsigned char i2c_return;
} I2C_SW_WRITE_t;


//***********************************************************************

